-- Mounty is a WoW addon which :
     - Creates macro that will make you mount your fastest flying mount in Outland (if you have one). 
     - Creates macro that will make you fastest mount either if you are shaman or drood will cast travel form.

-- By Pavle93 feel free to contact me pavleradoman@gmail.com

-- You can use this code in any forms

function Mounty_OnLoad()
  	this:RegisterEvent("PLAYER_ALIVE");
  	this:RegisterEvent("PLAYER_LOGIN");
	this:Hide();
end
function Mounty_OnEvent()
	if(event == "PLAYER_ALIVE" or event == "PLAYER_LOGIN") then
		SRflyingmount = "";
		SRgroundmount = "";
		for bag = 0,4 do -- check bags for mounts
			for slot = 1, GetContainerNumSlots(bag) do
				item = GetContainerItemLink(bag,slot);
				if (item) then
					_, itemId, _ = strsplit(":", item);
					MountyScanningTooltip = CreateFrame("GameTooltip", "MountyScanningTooltip", nil, "GameTooltipTemplate");
					MountyScanningTooltip:SetOwner(WorldFrame, "ANCHOR_NONE");
					MountyScanningTooltip:ClearLines();
					MountyScanningTooltip:SetBagItem(bag,slot);
					for i = 1, MountyScanningTooltip:NumLines() do
						lefttext = getglobal("MountyScanningTooltipTextLeft" .. i):GetText();
						if (lefttext) then 
							if (string.find(lefttext, "Requires Riding")) then
								if ((string.find(lefttext, "75") and SRgroundmount == "") or string.find(lefttext, "150")) then
									SRgroundmount = "item:"..itemId;
								end
								if ((string.find(lefttext, "225") and SRflyingmount == "") or string.find(lefttext, "300")) then
									SRflyingmount = "item:"..itemId;
								end
							end
						end
					end
				end
			end
		end 
		_, class = UnitClass("player"); -- check class-specific mounts in spellbook
		if (class == "DRUID" and GetSpellInfo("Flight Form") and SRflyingmount == "") then
			SRflyingmount = "Flight Form";
		end
		if (class == "DRUID" and GetSpellInfo("Swift Flight Form")) then
			SRflyingmount = "Swift Flight Form";
		end
		if (class == "DRUID" and GetSpellInfo("Travel Form") and SRgroundmount == "") then
			SRgroundmount = "Travel Form";
		end
		if (class == "SHAMAN" and GetSpellInfo("Ghost Wolf") and SRgroundmount == "") then
			SRgroundmount = "Ghost Wolf";
		end
		if (class == "WARLOCK" and GetSpellInfo("Summon Felsteed") and SRgroundmount == "") then
			SRgroundmount = "Summon Felsteed";
		end
		if (class == "WARLOCK" and GetSpellInfo("Summon Dreadsteed")) then
			SRgroundmount = "Summon Dreadsteed";
		end
		if (class == "PALADIN" and GetSpellInfo("Summon Warhorse") and SRgroundmount == "") then
			SRgroundmount = "Summon Warhorse";
		end
		if (class == "PALADIN" and GetSpellInfo("Summon Charger")) then
			SRgroundmount = "Summon Charger";
		end
		macroid = GetMacroIndexByName("Ride"); -- make the macro
		if (macroid == 0) then
			macroId = CreateMacro("Ride", 1, "", 1, 0);
		end
		body = "/cast ";
		if (SRflyingmount ~= "") then
			body = body.."[flyable, nobutton:2] "..SRflyingmount..";";
		end
		if (SRgroundmount ~= "") then
			body = body..SRgroundmount;
		end
		if (body == "/cast ") then
			DEFAULT_CHAT_FRAME:AddMessage("Mounty can't find a mount; if you have a mount in your bags, or a mount summoning spell in your spellbook, please file a bug report to pouzzler@free.fr.");
		end	
		EditMacro(macroid, "Ride", 1, body, 1, 0);
	end
end



